searchNodes=[{"doc":"Memorex is a Phoenix LiveView application for drilling/reviewing flashcards via a spaced-repetition system.","ref":"Memorex.html","title":"Memorex","type":"module"},{"doc":"A struct which contains various counts for a Memorex.Domain.Deck .","ref":"Memorex.DeckStats.html","title":"Memorex.DeckStats","type":"module"},{"doc":"","ref":"Memorex.DeckStats.html#new/2","title":"Memorex.DeckStats.new/2","type":"function"},{"doc":"","ref":"Memorex.DeckStats.html#t:t/0","title":"Memorex.DeckStats.t/0","type":"type"},{"doc":"Parses Memorex Markdown Memorex.Domain.Deck files. The Memorex.Parser is invoked from the mix task memorex.read_notes . This mix task invokes read_note_dirs/1 which is the main entry point to Memorex.Parser ; the rest of the funtions are implementation details (which are public simply so they can be tested in isolation).","ref":"Memorex.Parser.html","title":"Memorex.Parser","type":"module"},{"doc":"","ref":"Memorex.Parser.html#create_or_update_note/1","title":"Memorex.Parser.create_or_update_note/1","type":"function"},{"doc":"","ref":"Memorex.Parser.html#default_opts/0","title":"Memorex.Parser.default_opts/0","type":"function"},{"doc":"","ref":"Memorex.Parser.html#is_bidirectional_note?/2","title":"Memorex.Parser.is_bidirectional_note?/2","type":"function"},{"doc":"","ref":"Memorex.Parser.html#is_note_line?/2","title":"Memorex.Parser.is_note_line?/2","type":"function"},{"doc":"","ref":"Memorex.Parser.html#parse_file_contents/2","title":"Memorex.Parser.parse_file_contents/2","type":"function"},{"doc":"","ref":"Memorex.Parser.html#parse_line/2","title":"Memorex.Parser.parse_line/2","type":"function"},{"doc":"","ref":"Memorex.Parser.html#read_dir/2","title":"Memorex.Parser.read_dir/2","type":"function"},{"doc":"","ref":"Memorex.Parser.html#read_image_note/2","title":"Memorex.Parser.read_image_note/2","type":"function"},{"doc":"Reads in notes from directories, and in the process creates cards. Takes an array of directory names; e.g., [&quot;/note_dir1&quot;, &quot;/note_dir2&quot;] , etc. The existing notes in the database are marked with a flag prior to reading (flag :in_latest_parse? on Memorex.Domain.Note is set to false), and as the notes are read, existing notes have this flag toggled to true. New notes also have this flag set to true . At the end, notes in the database which have not had their flag set to true are expunged. These are notes which have either been deleted in the local filesystem content, or else their content has been modified (so they have been read in again as a new note; i.e., their drilling info is lost in the process). Note that this is the primary (and only) external API function to Memorex.Parser ; the other functions are public solely for purposes of testing.","ref":"Memorex.Parser.html#read_note_dirs/1","title":"Memorex.Parser.read_note_dirs/1","type":"function"},{"doc":"","ref":"Memorex.Parser.html#read_notes_file/2","title":"Memorex.Parser.read_notes_file/2","type":"function"},{"doc":"","ref":"Memorex.Parser.html#read_toml_deck_config/1","title":"Memorex.Parser.read_toml_deck_config/1","type":"function"},{"doc":"Some convenience functions for interacting with date/times.","ref":"Memorex.TimeUtils.html","title":"Memorex.TimeUtils","type":"module"},{"doc":"","ref":"Memorex.TimeUtils.html#now/0","title":"Memorex.TimeUtils.now/0","type":"function"},{"doc":"","ref":"Memorex.TimeUtils.html#timezone/0","title":"Memorex.TimeUtils.timezone/0","type":"function"},{"doc":"","ref":"Memorex.TimeUtils.html#to_timezone/2","title":"Memorex.TimeUtils.to_timezone/2","type":"function"},{"doc":"Reads the notes from the notes dirs $ mix memorex.read_notes","ref":"Mix.Tasks.Memorex.ReadNotes.html","title":"Mix.Tasks.Memorex.ReadNotes","type":"task"},{"doc":"A Memorex.Domain.Card is the entity in Memorex which is reviewed/drilled by MemorexWeb.ReviewLive . A Memorex.Domain.Card belongs to a Memorex.Domain.Note . The Memorex.Domain.Card contains only drilling-related info; the actual flashcard content is contained in the Memorex.Domain.Note .","ref":"Memorex.Domain.Card.html","title":"Memorex.Domain.Card","type":"module"},{"doc":"","ref":"Memorex.Domain.Card.html#answer/1","title":"Memorex.Domain.Card.answer/1","type":"function"},{"doc":"","ref":"Memorex.Domain.Card.html#answer_choices/0","title":"Memorex.Domain.Card.answer_choices/0","type":"function"},{"doc":"","ref":"Memorex.Domain.Card.html#card_statuses/0","title":"Memorex.Domain.Card.card_statuses/0","type":"function"},{"doc":"","ref":"Memorex.Domain.Card.html#card_types/0","title":"Memorex.Domain.Card.card_types/0","type":"function"},{"doc":"","ref":"Memorex.Domain.Card.html#changeset/2","title":"Memorex.Domain.Card.changeset/2","type":"function"},{"doc":"","ref":"Memorex.Domain.Card.html#increment_reps/1","title":"Memorex.Domain.Card.increment_reps/1","type":"function"},{"doc":"","ref":"Memorex.Domain.Card.html#is_image_card?/1","title":"Memorex.Domain.Card.is_image_card?/1","type":"function"},{"doc":"","ref":"Memorex.Domain.Card.html#question/1","title":"Memorex.Domain.Card.question/1","type":"function"},{"doc":"","ref":"Memorex.Domain.Card.html#set_due_field_in_changeset/2","title":"Memorex.Domain.Card.set_due_field_in_changeset/2","type":"function"},{"doc":"","ref":"Memorex.Domain.Card.html#t:answer_choice/0","title":"Memorex.Domain.Card.answer_choice/0","type":"type"},{"doc":"","ref":"Memorex.Domain.Card.html#t:card_status/0","title":"Memorex.Domain.Card.card_status/0","type":"type"},{"doc":"","ref":"Memorex.Domain.Card.html#t:card_type/0","title":"Memorex.Domain.Card.card_type/0","type":"type"},{"doc":"","ref":"Memorex.Domain.Card.html#t:t/0","title":"Memorex.Domain.Card.t/0","type":"type"},{"doc":"A Memorex.Domain.Card has one or more Memorex.Domain.CardLog s; every time you answer a card when reviewing/drilling (via MemorexWeb.ReviewLive ) a Memorex.Domain.CardLog entry is created.","ref":"Memorex.Domain.CardLog.html","title":"Memorex.Domain.CardLog","type":"module"},{"doc":"","ref":"Memorex.Domain.CardLog.html#new/4","title":"Memorex.Domain.CardLog.new/4","type":"function"},{"doc":"","ref":"Memorex.Domain.CardLog.html#t:t/0","title":"Memorex.Domain.CardLog.t/0","type":"type"},{"doc":"A Memorex.Domain.Deck contains Memorex.Domain.Note s (which in turn can have one or two Memorex.Domain.Card s associated with them). A Memorex.Domain.Deck can be read in from a single Markdown file (in which case the deck name is the name of the Markdown file, minus the .md extension) or from a directory which contains multiple Markdown files (in which case the deck name is the name of the directory containing the Markdown files), or from a deck directory which contains image file/text file pairs (see Memorex.Domain.Note for more detail). Memorex.Domain.Deck s are re-read each time the mix task memorex.read_notes is run.","ref":"Memorex.Domain.Deck.html","title":"Memorex.Domain.Deck","type":"module"},{"doc":"","ref":"Memorex.Domain.Deck.html#changeset/2","title":"Memorex.Domain.Deck.changeset/2","type":"function"},{"doc":"","ref":"Memorex.Domain.Deck.html#t:t/0","title":"Memorex.Domain.Deck.t/0","type":"type"},{"doc":"There are two types of Memorex.Domain.Note s in Memorex . The first type (called &quot;text notes&quot;) consists of a single line in a Memorex.Domain.Deck Markdown file which contains either the bidirectional or unidirectional delimitter (which are by default &quot;⮂&quot; and &quot;→&quot;, respectively). The primary key of a text note is a UUID which is a hash of the note content (together with the note category, which is the name of the Markdown file if this deck is a directory which contains multple Markdown files). Notes are flagged when the Memorex.Deck parsing starts (via mix memorex.read_notes ), and any Memorex.Domain.Note which does not show up in the current parsing of the Memorex.Domain.Deck is purged (so if the Memorex.Domain.Note has been edited in the Markdown file, it will be deleted and re-created on the next reading/parsing of the Memorex.Domain.Deck ). The second type of Memorex.Domain.Note s are &quot;image notes&quot;. An image file is placed in a Memorex.Domain.Deck directory on the filesystem. A text file with the same name as the image file (but with the extension &quot;.txt&quot;) is placed as a sibling to the image file. The text file contains the answer to the image file. The UUID for image notes is a hash of the contents of the image, the image file path, and the contents of the text file, so the UUID will change if the image file itself is changed, the file is moved, or the answer in the text file is changed. Image notes can have the extension &quot;.jpg&quot;, &quot;.jpeg&quot;, &quot;.png&quot;, &quot;.webp&quot;, &quot;.svg&quot;, or &quot;.gif&quot;.","ref":"Memorex.Domain.Note.html","title":"Memorex.Domain.Note","type":"module"},{"doc":"","ref":"Memorex.Domain.Note.html#content_to_uuid/4","title":"Memorex.Domain.Note.content_to_uuid/4","type":"function"},{"doc":"","ref":"Memorex.Domain.Note.html#new/1","title":"Memorex.Domain.Note.new/1","type":"function"},{"doc":"","ref":"Memorex.Domain.Note.html#sha1/1","title":"Memorex.Domain.Note.sha1/1","type":"function"},{"doc":"","ref":"Memorex.Domain.Note.html#sha1_to_uuid/1","title":"Memorex.Domain.Note.sha1_to_uuid/1","type":"function"},{"doc":"","ref":"Memorex.Domain.Note.html#t:t/0","title":"Memorex.Domain.Note.t/0","type":"type"},{"doc":"An Ecto repo which is used to store the drilling information (e.g., when a card is due, its interval, etc.) and a COPY of the Memorex.Domain.Note content (which is refreshed/re-created when the Memorex.Domain.Deck Markdown files are re-read from the filesystem via the Mix task Mix.Tasks.Memorex.ReadNotes ).","ref":"Memorex.Ecto.Repo.html","title":"Memorex.Ecto.Repo","type":"module"},{"doc":"Callback implementation for Ecto.Repo.aggregate/3 .","ref":"Memorex.Ecto.Repo.html#aggregate/3","title":"Memorex.Ecto.Repo.aggregate/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.aggregate/4 .","ref":"Memorex.Ecto.Repo.html#aggregate/4","title":"Memorex.Ecto.Repo.aggregate/4","type":"function"},{"doc":"Callback implementation for Ecto.Repo.all/2 .","ref":"Memorex.Ecto.Repo.html#all/2","title":"Memorex.Ecto.Repo.all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checked_out?/0 .","ref":"Memorex.Ecto.Repo.html#checked_out?/0","title":"Memorex.Ecto.Repo.checked_out?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checkout/2 .","ref":"Memorex.Ecto.Repo.html#checkout/2","title":"Memorex.Ecto.Repo.checkout/2","type":"function"},{"doc":"","ref":"Memorex.Ecto.Repo.html#child_spec/1","title":"Memorex.Ecto.Repo.child_spec/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.config/0 .","ref":"Memorex.Ecto.Repo.html#config/0","title":"Memorex.Ecto.Repo.config/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.default_options/1 .","ref":"Memorex.Ecto.Repo.html#default_options/1","title":"Memorex.Ecto.Repo.default_options/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete!/2 .","ref":"Memorex.Ecto.Repo.html#delete!/2","title":"Memorex.Ecto.Repo.delete!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete/2 .","ref":"Memorex.Ecto.Repo.html#delete/2","title":"Memorex.Ecto.Repo.delete/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete_all/2 .","ref":"Memorex.Ecto.Repo.html#delete_all/2","title":"Memorex.Ecto.Repo.delete_all/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that forces all connections in the pool to disconnect within the given interval. See Ecto.Adapters.SQL.disconnect_all/3 for more information.","ref":"Memorex.Ecto.Repo.html#disconnect_all/2","title":"Memorex.Ecto.Repo.disconnect_all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.exists?/2 .","ref":"Memorex.Ecto.Repo.html#exists?/2","title":"Memorex.Ecto.Repo.exists?/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar depending on the adapter to obtain statistics for the given query. See Ecto.Adapters.SQL.explain/4 for more information.","ref":"Memorex.Ecto.Repo.html#explain/3","title":"Memorex.Ecto.Repo.explain/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get!/3 .","ref":"Memorex.Ecto.Repo.html#get!/3","title":"Memorex.Ecto.Repo.get!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get/3 .","ref":"Memorex.Ecto.Repo.html#get/3","title":"Memorex.Ecto.Repo.get/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by!/3 .","ref":"Memorex.Ecto.Repo.html#get_by!/3","title":"Memorex.Ecto.Repo.get_by!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by/3 .","ref":"Memorex.Ecto.Repo.html#get_by/3","title":"Memorex.Ecto.Repo.get_by/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_dynamic_repo/0 .","ref":"Memorex.Ecto.Repo.html#get_dynamic_repo/0","title":"Memorex.Ecto.Repo.get_dynamic_repo/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.in_transaction?/0 .","ref":"Memorex.Ecto.Repo.html#in_transaction?/0","title":"Memorex.Ecto.Repo.in_transaction?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert!/2 .","ref":"Memorex.Ecto.Repo.html#insert!/2","title":"Memorex.Ecto.Repo.insert!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert/2 .","ref":"Memorex.Ecto.Repo.html#insert/2","title":"Memorex.Ecto.Repo.insert/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_all/3 .","ref":"Memorex.Ecto.Repo.html#insert_all/3","title":"Memorex.Ecto.Repo.insert_all/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update!/2 .","ref":"Memorex.Ecto.Repo.html#insert_or_update!/2","title":"Memorex.Ecto.Repo.insert_or_update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update/2 .","ref":"Memorex.Ecto.Repo.html#insert_or_update/2","title":"Memorex.Ecto.Repo.insert_or_update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.load/2 .","ref":"Memorex.Ecto.Repo.html#load/2","title":"Memorex.Ecto.Repo.load/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one!/2 .","ref":"Memorex.Ecto.Repo.html#one!/2","title":"Memorex.Ecto.Repo.one!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one/2 .","ref":"Memorex.Ecto.Repo.html#one/2","title":"Memorex.Ecto.Repo.one/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.preload/3 .","ref":"Memorex.Ecto.Repo.html#preload/3","title":"Memorex.Ecto.Repo.preload/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.prepare_query/3 .","ref":"Memorex.Ecto.Repo.html#prepare_query/3","title":"Memorex.Ecto.Repo.prepare_query/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.put_dynamic_repo/1 .","ref":"Memorex.Ecto.Repo.html#put_dynamic_repo/1","title":"Memorex.Ecto.Repo.put_dynamic_repo/1","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query!/4 for more information.","ref":"Memorex.Ecto.Repo.html#query!/3","title":"Memorex.Ecto.Repo.query!/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/4 for more information.","ref":"Memorex.Ecto.Repo.html#query/3","title":"Memorex.Ecto.Repo.query/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many!/4 for more information.","ref":"Memorex.Ecto.Repo.html#query_many!/3","title":"Memorex.Ecto.Repo.query_many!/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many/4 for more information.","ref":"Memorex.Ecto.Repo.html#query_many/3","title":"Memorex.Ecto.Repo.query_many/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload!/2 .","ref":"Memorex.Ecto.Repo.html#reload!/2","title":"Memorex.Ecto.Repo.reload!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload/2 .","ref":"Memorex.Ecto.Repo.html#reload/2","title":"Memorex.Ecto.Repo.reload/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.rollback/1 .","ref":"Memorex.Ecto.Repo.html#rollback/1","title":"Memorex.Ecto.Repo.rollback/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.start_link/1 .","ref":"Memorex.Ecto.Repo.html#start_link/1","title":"Memorex.Ecto.Repo.start_link/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stop/1 .","ref":"Memorex.Ecto.Repo.html#stop/1","title":"Memorex.Ecto.Repo.stop/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stream/2 .","ref":"Memorex.Ecto.Repo.html#stream/2","title":"Memorex.Ecto.Repo.stream/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.to_sql/3 for more information.","ref":"Memorex.Ecto.Repo.html#to_sql/2","title":"Memorex.Ecto.Repo.to_sql/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.transaction/2 .","ref":"Memorex.Ecto.Repo.html#transaction/2","title":"Memorex.Ecto.Repo.transaction/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update!/2 .","ref":"Memorex.Ecto.Repo.html#update!/2","title":"Memorex.Ecto.Repo.update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update/2 .","ref":"Memorex.Ecto.Repo.html#update/2","title":"Memorex.Ecto.Repo.update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update_all/3 .","ref":"Memorex.Ecto.Repo.html#update_all/3","title":"Memorex.Ecto.Repo.update_all/3","type":"function"},{"doc":"This schema enables the Ecto primary keys to be UUIDs by default.","ref":"Memorex.Ecto.Schema.html","title":"Memorex.Ecto.Schema","type":"module"},{"doc":"","ref":"Memorex.Ecto.Schema.html#t:id/0","title":"Memorex.Ecto.Schema.id/0","type":"type"},{"doc":"An Ecto type which lets Timex.Duration be stored in Postgres as an integer (representing number of seconds). The Timex.Duration is converted to seconds when it is written to the database, and is converted back to a Timex.Duration when it is read from the database. To use, simply mark a field as type TimexDuration in the schema file. For example, see field :interval on Memorex.Domain.Card , e.g., field :interval, TimexDuration See here for more info on creating Ecto types.","ref":"Memorex.Ecto.TimexDuration.html","title":"Memorex.Ecto.TimexDuration","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Memorex.Ecto.TimexDuration.html#embed_as/1","title":"Memorex.Ecto.TimexDuration.embed_as/1","type":"function"},{"doc":"Memorex.Scheduler.CardReviewer is used by the MemorexWeb.ReviewLive Live View to review cards. Meorex.Domain.Card s are answered, and in the process Memorex.Domain.CardLog s are created. Note that in contrast to Memorex.Scheduler.CardStateMachine , Memorex.Scheduler.CardReviewer writes content to the database (the updated Memorex.Domain.Card , along with the Memorex.Domain.CardLog .)","ref":"Memorex.Scheduler.CardReviewer.html","title":"Memorex.Scheduler.CardReviewer","type":"module"},{"doc":"Answers a Memorex.Domain.Card , and updates it in the database (note no Memorex.Domain.CardLog is created)","ref":"Memorex.Scheduler.CardReviewer.html#answer_card/4","title":"Memorex.Scheduler.CardReviewer.answer_card/4","type":"function"},{"doc":"Answers a Memorex.Domain.Card , and updates it in the database (and also creates a Memorex.Domain.CardLog )","ref":"Memorex.Scheduler.CardReviewer.html#answer_card_and_create_log_entry/5","title":"Memorex.Scheduler.CardReviewer.answer_card_and_create_log_entry/5","type":"function"},{"doc":"","ref":"Memorex.Scheduler.CardReviewer.html#bracket_time_to_answer/2","title":"Memorex.Scheduler.CardReviewer.bracket_time_to_answer/2","type":"function"},{"doc":"Computes the time to answer this card. Note that the time to answer is bracketed by :min_time_to_answer and :max_time_to_answer on Memorex.Scheduler.Config . The thought is that if you walk away from the computer when drilling, the stored time_to_answer will be stored as at most :max_time_to_answer .","ref":"Memorex.Scheduler.CardReviewer.html#time_to_answer/3","title":"Memorex.Scheduler.CardReviewer.time_to_answer/3","type":"function"},{"doc":"This is the heart of the Anki SM-2 algorithm. Note that this file consists of pure functions; Memorex.Domain.Card structs come into the answer_card/4 function, and a map containing changes are returned. There is no database interaction in this file. Time is deterministic (i.e., there are no Timex.now() calls within this module), and the specific value of the current time is fed into each function. Memorex.Scheduler.CardStateMachine is not truly a state machine per se (as it actually maintains no state), but is really a set of transforms on Memorex.Domain.Card s.","ref":"Memorex.Scheduler.CardStateMachine.html","title":"Memorex.Scheduler.CardStateMachine","type":"module"},{"doc":"This is the main function used when drilling/reviewing Memorex.Domain.Card s. Cards start out as :new , and then progress to :learn and then :review based on the Anki algorithm. If a :review card is failed (by answering :again ), then it becomes a :relearn card. Note that a map containing the difference in the card state is returned by answer_card/4 , not a new version of the card. Only values that actually modified by the answer are returned in this map. Also note that Memorex.Domain.Card values such as :reps are incremented outside of Memorex.Scheduler.CardStateMachine in Memorex.Scheduler.CardReviewer (otherwise every function in this file would increment :rep by one, which seemed redundant). The :due field on Memorex.Domain.Card is also computed outside of Memorex.Scheduler.CardStateMachine based on the value of :interval ; i.e., a new :interval is computed in Memorex.Scheduler.CardStateMachine and its value is added to the old :due datetime to find a new :due in Memorex.Scheduler.CardReviewer .","ref":"Memorex.Scheduler.CardStateMachine.html#answer_card/4","title":"Memorex.Scheduler.CardStateMachine.answer_card/4","type":"function"},{"doc":"","ref":"Memorex.Scheduler.CardStateMachine.html#cap_duration/2","title":"Memorex.Scheduler.CardStateMachine.cap_duration/2","type":"function"},{"doc":"","ref":"Memorex.Scheduler.CardStateMachine.html#convert_new_card_to_learn_card/3","title":"Memorex.Scheduler.CardStateMachine.convert_new_card_to_learn_card/3","type":"function"},{"doc":"The configuration for the Anki SM-2 algorithm . See a detailed list of the Anki settings in this Anki forum The Anki manual also contains a lot of information. These values are modified by deck config toml files, and also by environment variables (see config/runtime.exs ). Memorex Setting Anki Setting Anki Default new_cards_per_day new cards per day 20 max_reviews_per_day maximum reviews per day 200 - - - learn_ahead_time_interval learn ahead time (in settings?) 20 minutes - - - learn_steps learning steps [1 min, 10 min] graduating_interval_good graduating interval 1 day graduating_interval_easy easy interval 4 days - - - relearn_steps relearning steps [10 min] - - - initial_ease starting ease 2.5 - - - easy_multiplier easy bonus 1.3 hard_multiplier hard interval 1.2 lapse_multiplier new interval (? I think so) 0.0 interval_multiplier interval modifier 1.0 - - - ease_again &lt;not in settings&gt; -0.2 ease_hard &lt;not in settings&gt; -0.15 ease_good &lt;not in settings&gt; 0.0 ease_easy &lt;not in settings&gt; 0.15 ease_minimum &lt;not in settings&gt; 1.3 - - - max_review_interval maximum interval 100 years min_review_interval minimum interval 1 day - - - leech_threshold leech threshhold 8 lapses - - - min_time_to_answer &lt;not in settings&gt; 1 sec max_time_to_answer maximum answer seconds 1 min - - - relearn_easy_adj NOT SURE WHERE THIS IS FROM 1 day - - - timezone timezone 1 day","ref":"Memorex.Scheduler.Config.html","title":"Memorex.Scheduler.Config","type":"module"},{"doc":"Returns the default Memorex.Schedler.Config as returned from the application environment (e.g., environment variables. Converts from the application env map to an actual Memorex.Scheduler.Config struct.","ref":"Memorex.Scheduler.Config.html#default/0","title":"Memorex.Scheduler.Config.default/0","type":"function"},{"doc":"Merges in a map into the Memorex.Scheduler.Config . This is used to merge in deck-specific configuration from toml config files.","ref":"Memorex.Scheduler.Config.html#merge/2","title":"Memorex.Scheduler.Config.merge/2","type":"function"},{"doc":"","ref":"Memorex.Scheduler.Config.html#t:t/0","title":"Memorex.Scheduler.Config.t/0","type":"type"},{"doc":"Functions for interacting with Memorex.Domain.CardLog s.","ref":"Memorex.CardLogs.html","title":"Memorex.CardLogs","type":"module"},{"doc":"","ref":"Memorex.CardLogs.html#all/0","title":"Memorex.CardLogs.all/0","type":"function"},{"doc":"","ref":"Memorex.CardLogs.html#count/1","title":"Memorex.CardLogs.count/1","type":"function"},{"doc":"","ref":"Memorex.CardLogs.html#for_day/3","title":"Memorex.CardLogs.for_day/3","type":"function"},{"doc":"","ref":"Memorex.CardLogs.html#for_deck/3","title":"Memorex.CardLogs.for_deck/3","type":"function"},{"doc":"","ref":"Memorex.CardLogs.html#reviews_count_for_day/3","title":"Memorex.CardLogs.reviews_count_for_day/3","type":"function"},{"doc":"","ref":"Memorex.CardLogs.html#where_card_type/2","title":"Memorex.CardLogs.where_card_type/2","type":"function"},{"doc":"Functions for interacting with Memorex.Domain.Card s.","ref":"Memorex.Cards.html","title":"Memorex.Cards","type":"module"},{"doc":"","ref":"Memorex.Cards.html#cards_for_deck/2","title":"Memorex.Cards.cards_for_deck/2","type":"function"},{"doc":"Converts a Memorex.Domain.Card from a :new card to a :learn card (and in the process creates a Memorex.Domain.CardLog entry).","ref":"Memorex.Cards.html#convert_new_card_to_learn_card/3","title":"Memorex.Cards.convert_new_card_to_learn_card/3","type":"function"},{"doc":"","ref":"Memorex.Cards.html#count/1","title":"Memorex.Cards.count/1","type":"function"},{"doc":"","ref":"Memorex.Cards.html#count/2","title":"Memorex.Cards.count/2","type":"function"},{"doc":"","ref":"Memorex.Cards.html#create_from_note/1","title":"Memorex.Cards.create_from_note/1","type":"function"},{"doc":"","ref":"Memorex.Cards.html#due_count/2","title":"Memorex.Cards.due_count/2","type":"function"},{"doc":"","ref":"Memorex.Cards.html#get_card!/1","title":"Memorex.Cards.get_card!/1","type":"function"},{"doc":"","ref":"Memorex.Cards.html#get_interval_choices/3","title":"Memorex.Cards.get_interval_choices/3","type":"function"},{"doc":"","ref":"Memorex.Cards.html#get_one_random_due_card/2","title":"Memorex.Cards.get_one_random_due_card/2","type":"function"},{"doc":"","ref":"Memorex.Cards.html#set_new_cards_in_deck_to_learn_cards/4","title":"Memorex.Cards.set_new_cards_in_deck_to_learn_cards/4","type":"function"},{"doc":"","ref":"Memorex.Cards.html#update/2","title":"Memorex.Cards.update/2","type":"function"},{"doc":"Updates a card, and in the process sets the :due field, and also increments the rep count","ref":"Memorex.Cards.html#update_card_when_reviewing!/3","title":"Memorex.Cards.update_card_when_reviewing!/3","type":"function"},{"doc":"","ref":"Memorex.Cards.html#where_due/2","title":"Memorex.Cards.where_due/2","type":"function"},{"doc":"Functions for interacting with Memorex.Domain.Deck s.","ref":"Memorex.Decks.html","title":"Memorex.Decks","type":"module"},{"doc":"Finds an existing deck by name, or else creates it.","ref":"Memorex.Decks.html#find_or_create!/1","title":"Memorex.Decks.find_or_create!/1","type":"function"},{"doc":"Updates the config for a Memorex.Domain.Deck from the values contained in a TOML deck config file. Note that only the values from the config file are stored (which might be a subset of the available values contained in Memorex.Scheduler.Config ), and they are stored in the database as a Map , NOT as a Memorex.Scheduler.Config struct.","ref":"Memorex.Decks.html#update_config/2","title":"Memorex.Decks.update_config/2","type":"function"},{"doc":"Functions for interacting with Memorex.Domain.Notes s.","ref":"Memorex.Notes.html","title":"Memorex.Notes","type":"module"},{"doc":"","ref":"Memorex.Notes.html#clear_parse_flags/0","title":"Memorex.Notes.clear_parse_flags/0","type":"function"},{"doc":"Used to purge notes which are &quot;orphaned&quot; when reading in the Markdown file; that is, they have either been deleted from the Markdown file, or else their content has been edited (which causes their UUID to change).","ref":"Memorex.Notes.html#delete_notes_without_flag_set/0","title":"Memorex.Notes.delete_notes_without_flag_set/0","type":"function"},{"doc":"","ref":"Memorex.Notes.html#set_parse_flag/1","title":"Memorex.Notes.set_parse_flag/1","type":"function"},{"doc":"The entrypoint for defining your web interface, such as controllers, views, channels and so on. This can be used in your application as: use MemorexWeb , :controller use MemorexWeb , :view The definitions below will be executed for every view, controller, etc, so keep them short and clean, focused on imports, uses and aliases. Do NOT define functions inside the quoted expressions below. Instead, define any helper function in modules and import those modules here.","ref":"MemorexWeb.html","title":"MemorexWeb","type":"module"},{"doc":"When used, dispatch to the appropriate controller/view/etc.","ref":"MemorexWeb.html#__using__/1","title":"MemorexWeb.__using__/1","type":"macro"},{"doc":"","ref":"MemorexWeb.html#channel/0","title":"MemorexWeb.channel/0","type":"function"},{"doc":"","ref":"MemorexWeb.html#component/0","title":"MemorexWeb.component/0","type":"function"},{"doc":"","ref":"MemorexWeb.html#controller/0","title":"MemorexWeb.controller/0","type":"function"},{"doc":"","ref":"MemorexWeb.html#live_component/0","title":"MemorexWeb.live_component/0","type":"function"},{"doc":"","ref":"MemorexWeb.html#live_view/0","title":"MemorexWeb.live_view/0","type":"function"},{"doc":"","ref":"MemorexWeb.html#router/0","title":"MemorexWeb.router/0","type":"function"},{"doc":"","ref":"MemorexWeb.html#view/0","title":"MemorexWeb.view/0","type":"function"},{"doc":"A Phoenix LiveView which shows a list of all decks. This is the main UI entry point to the application.","ref":"MemorexWeb.DecksLive.html","title":"MemorexWeb.DecksLive","type":"module"},{"doc":"Conveniences for translating and building error messages.","ref":"MemorexWeb.ErrorHelpers.html","title":"MemorexWeb.ErrorHelpers","type":"module"},{"doc":"Generates tag for inlined form input errors.","ref":"MemorexWeb.ErrorHelpers.html#error_tag/2","title":"MemorexWeb.ErrorHelpers.error_tag/2","type":"function"},{"doc":"Translates an error message using gettext.","ref":"MemorexWeb.ErrorHelpers.html#translate_error/1","title":"MemorexWeb.ErrorHelpers.translate_error/1","type":"function"},{"doc":"","ref":"MemorexWeb.ErrorView.html","title":"MemorexWeb.ErrorView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"MemorexWeb.ErrorView.html#__resource__/0","title":"MemorexWeb.ErrorView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"MemorexWeb.ErrorView.html#render/2","title":"MemorexWeb.ErrorView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"MemorexWeb.ErrorView.html#template_not_found/2","title":"MemorexWeb.ErrorView.template_not_found/2","type":"function"},{"doc":"A module providing Internationalization with a gettext-based API. By using Gettext , your module gains a set of macros for translations, for example: import MemorexWeb.Gettext # Simple translation gettext ( &quot;Here is the string to translate&quot; ) # Plural translation ngettext ( &quot;Here is the string to translate&quot; , &quot;Here are the strings to translate&quot; , 3 ) # Domain-based translation dgettext ( &quot;errors&quot; , &quot;Here is the error message to translate&quot; ) See the Gettext Docs for detailed usage.","ref":"MemorexWeb.Gettext.html","title":"MemorexWeb.Gettext","type":"module"},{"doc":"Callback implementation for Gettext.Backend.dgettext/3 .","ref":"MemorexWeb.Gettext.html#dgettext/3","title":"MemorexWeb.Gettext.dgettext/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dgettext_noop/2 .","ref":"MemorexWeb.Gettext.html#dgettext_noop/2","title":"MemorexWeb.Gettext.dgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext/5 .","ref":"MemorexWeb.Gettext.html#dngettext/5","title":"MemorexWeb.Gettext.dngettext/5","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext_noop/3 .","ref":"MemorexWeb.Gettext.html#dngettext_noop/3","title":"MemorexWeb.Gettext.dngettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpgettext/4 .","ref":"MemorexWeb.Gettext.html#dpgettext/4","title":"MemorexWeb.Gettext.dpgettext/4","type":"macro"},{"doc":"","ref":"MemorexWeb.Gettext.html#dpgettext_noop/3","title":"MemorexWeb.Gettext.dpgettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpngettext/6 .","ref":"MemorexWeb.Gettext.html#dpngettext/6","title":"MemorexWeb.Gettext.dpngettext/6","type":"macro"},{"doc":"","ref":"MemorexWeb.Gettext.html#dpngettext_noop/4","title":"MemorexWeb.Gettext.dpngettext_noop/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext/2 .","ref":"MemorexWeb.Gettext.html#gettext/2","title":"MemorexWeb.Gettext.gettext/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_comment/1 .","ref":"MemorexWeb.Gettext.html#gettext_comment/1","title":"MemorexWeb.Gettext.gettext_comment/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_noop/1 .","ref":"MemorexWeb.Gettext.html#gettext_noop/1","title":"MemorexWeb.Gettext.gettext_noop/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_bindings/2 .","ref":"MemorexWeb.Gettext.html#handle_missing_bindings/2","title":"MemorexWeb.Gettext.handle_missing_bindings/2","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_plural_translation/6 .","ref":"MemorexWeb.Gettext.html#handle_missing_plural_translation/6","title":"MemorexWeb.Gettext.handle_missing_plural_translation/6","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_translation/4 .","ref":"MemorexWeb.Gettext.html#handle_missing_translation/4","title":"MemorexWeb.Gettext.handle_missing_translation/4","type":"function"},{"doc":"","ref":"MemorexWeb.Gettext.html#lgettext/5","title":"MemorexWeb.Gettext.lgettext/5","type":"function"},{"doc":"","ref":"MemorexWeb.Gettext.html#lngettext/7","title":"MemorexWeb.Gettext.lngettext/7","type":"function"},{"doc":"Callback implementation for Gettext.Backend.ngettext/4 .","ref":"MemorexWeb.Gettext.html#ngettext/4","title":"MemorexWeb.Gettext.ngettext/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.ngettext_noop/2 .","ref":"MemorexWeb.Gettext.html#ngettext_noop/2","title":"MemorexWeb.Gettext.ngettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pgettext/3 .","ref":"MemorexWeb.Gettext.html#pgettext/3","title":"MemorexWeb.Gettext.pgettext/3","type":"macro"},{"doc":"","ref":"MemorexWeb.Gettext.html#pgettext_noop/2","title":"MemorexWeb.Gettext.pgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pngettext/5 .","ref":"MemorexWeb.Gettext.html#pngettext/5","title":"MemorexWeb.Gettext.pngettext/5","type":"macro"},{"doc":"","ref":"MemorexWeb.Gettext.html#pngettext_noop/3","title":"MemorexWeb.Gettext.pngettext_noop/3","type":"macro"},{"doc":"","ref":"MemorexWeb.LayoutView.html","title":"MemorexWeb.LayoutView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"MemorexWeb.LayoutView.html#__resource__/0","title":"MemorexWeb.LayoutView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"MemorexWeb.LayoutView.html#render/2","title":"MemorexWeb.LayoutView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"MemorexWeb.LayoutView.html#template_not_found/2","title":"MemorexWeb.LayoutView.template_not_found/2","type":"function"},{"doc":"The main LiveView for drilling/reviewing Memorex.Domain.Card s","ref":"MemorexWeb.ReviewLive.html","title":"MemorexWeb.ReviewLive","type":"module"},{"doc":"","ref":"MemorexWeb.ReviewLive.html#debug_mode?/0","title":"MemorexWeb.ReviewLive.debug_mode?/0","type":"function"},{"doc":"","ref":"MemorexWeb.ReviewLive.html#hide_debug_info/1","title":"MemorexWeb.ReviewLive.hide_debug_info/1","type":"function"},{"doc":"","ref":"MemorexWeb.ReviewLive.html#initially_show_debug_info?/0","title":"MemorexWeb.ReviewLive.initially_show_debug_info?/0","type":"function"},{"doc":"Callback implementation for Phoenix.LiveView.render/1 .","ref":"MemorexWeb.ReviewLive.html#render/1","title":"MemorexWeb.ReviewLive.render/1","type":"function"},{"doc":"","ref":"MemorexWeb.ReviewLive.html#show_debug_info/1","title":"MemorexWeb.ReviewLive.show_debug_info/1","type":"function"},{"doc":"Module with named helpers generated from MemorexWeb.Router.","ref":"MemorexWeb.Router.Helpers.html","title":"MemorexWeb.Router.Helpers","type":"module"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_edit_path/3","title":"MemorexWeb.Router.Helpers.card_edit_path/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_edit_path/4","title":"MemorexWeb.Router.Helpers.card_edit_path/4","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_edit_url/3","title":"MemorexWeb.Router.Helpers.card_edit_url/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_edit_url/4","title":"MemorexWeb.Router.Helpers.card_edit_url/4","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_index_path/2","title":"MemorexWeb.Router.Helpers.card_index_path/2","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_index_path/3","title":"MemorexWeb.Router.Helpers.card_index_path/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_index_url/2","title":"MemorexWeb.Router.Helpers.card_index_url/2","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_index_url/3","title":"MemorexWeb.Router.Helpers.card_index_url/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_show_path/3","title":"MemorexWeb.Router.Helpers.card_show_path/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_show_path/4","title":"MemorexWeb.Router.Helpers.card_show_path/4","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_show_url/3","title":"MemorexWeb.Router.Helpers.card_show_url/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#card_show_url/4","title":"MemorexWeb.Router.Helpers.card_show_url/4","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#decks_path/2","title":"MemorexWeb.Router.Helpers.decks_path/2","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#decks_path/3","title":"MemorexWeb.Router.Helpers.decks_path/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#decks_url/2","title":"MemorexWeb.Router.Helpers.decks_url/2","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#decks_url/3","title":"MemorexWeb.Router.Helpers.decks_url/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#live_dashboard_path/2","title":"MemorexWeb.Router.Helpers.live_dashboard_path/2","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#live_dashboard_path/3","title":"MemorexWeb.Router.Helpers.live_dashboard_path/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#live_dashboard_path/4","title":"MemorexWeb.Router.Helpers.live_dashboard_path/4","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#live_dashboard_path/5","title":"MemorexWeb.Router.Helpers.live_dashboard_path/5","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#live_dashboard_url/2","title":"MemorexWeb.Router.Helpers.live_dashboard_url/2","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#live_dashboard_url/3","title":"MemorexWeb.Router.Helpers.live_dashboard_url/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#live_dashboard_url/4","title":"MemorexWeb.Router.Helpers.live_dashboard_url/4","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#live_dashboard_url/5","title":"MemorexWeb.Router.Helpers.live_dashboard_url/5","type":"function"},{"doc":"Generates the path information including any necessary prefix.","ref":"MemorexWeb.Router.Helpers.html#path/2","title":"MemorexWeb.Router.Helpers.path/2","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#review_path/2","title":"MemorexWeb.Router.Helpers.review_path/2","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#review_path/3","title":"MemorexWeb.Router.Helpers.review_path/3","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#review_url/2","title":"MemorexWeb.Router.Helpers.review_url/2","type":"function"},{"doc":"","ref":"MemorexWeb.Router.Helpers.html#review_url/3","title":"MemorexWeb.Router.Helpers.review_url/3","type":"function"},{"doc":"Generates an integrity hash to a static asset given its file path.","ref":"MemorexWeb.Router.Helpers.html#static_integrity/2","title":"MemorexWeb.Router.Helpers.static_integrity/2","type":"function"},{"doc":"Generates path to a static asset given its file path.","ref":"MemorexWeb.Router.Helpers.html#static_path/2","title":"MemorexWeb.Router.Helpers.static_path/2","type":"function"},{"doc":"Generates url to a static asset given its file path.","ref":"MemorexWeb.Router.Helpers.html#static_url/2","title":"MemorexWeb.Router.Helpers.static_url/2","type":"function"},{"doc":"Generates the connection/endpoint base URL without any path information.","ref":"MemorexWeb.Router.Helpers.html#url/1","title":"MemorexWeb.Router.Helpers.url/1","type":"function"},{"doc":"Helper functions used by various LiveViews.","ref":"MemorexWeb.SharedViewHelpers.html","title":"MemorexWeb.SharedViewHelpers","type":"module"},{"doc":"","ref":"MemorexWeb.SharedViewHelpers.html#ease_factor/1","title":"MemorexWeb.SharedViewHelpers.ease_factor/1","type":"function"},{"doc":"","ref":"MemorexWeb.SharedViewHelpers.html#format/1","title":"MemorexWeb.SharedViewHelpers.format/1","type":"function"},{"doc":"","ref":"MemorexWeb.SharedViewHelpers.html#format_datetime/1","title":"MemorexWeb.SharedViewHelpers.format_datetime/1","type":"function"},{"doc":"","ref":"MemorexWeb.SharedViewHelpers.html#format_iso_datetime/1","title":"MemorexWeb.SharedViewHelpers.format_iso_datetime/1","type":"function"},{"doc":"","ref":"MemorexWeb.SharedViewHelpers.html#img_alt/1","title":"MemorexWeb.SharedViewHelpers.img_alt/1","type":"function"},{"doc":"","ref":"MemorexWeb.SharedViewHelpers.html#img_src/1","title":"MemorexWeb.SharedViewHelpers.img_src/1","type":"function"},{"doc":"","ref":"MemorexWeb.SharedViewHelpers.html#page_id/1","title":"MemorexWeb.SharedViewHelpers.page_id/1","type":"function"},{"doc":"","ref":"MemorexWeb.SharedViewHelpers.html#truncate/2","title":"MemorexWeb.SharedViewHelpers.truncate/2","type":"function"},{"doc":"Memorex is a space repetition system written in Elixir and implemented as a Phoenix LiveView application. You can read its documentation here . Memorex utilizes Anki's spaced repetition algorithm, which is itself based on the SuperMemo SM-2 algorithm . Unlike Anki, Memorex stores the flashcard content (i.e., notes) in Markdown files on your local filesystem (or as image files, each with an associated text file which contains the description of the image file). The database is only used to store information related to drilling/reviewing the flashcards, such as the due date for a card, its time interval, the number of repetitions, etc. To use Memorex, first get it running on your local system. First, you'll need to set an environment variable MEMOREX_NOTE_DIRS which points to one or more directories on your filesystem which contain Markdown files and/or directories with your flashcard content. If you're using direnv , then see .envrc.sample for an example .envrc file (note that only MEMOREX_NOTE_DIRS is required). mix deps . get mix deps . compile mix ecto . setup Then create one or more Markdown files with notes (or image files with similarly named text file which contains the &quot;answer&quot;); see test/fixtures/contains_multiple_decks for some examples (using test data), or vim-flashcards for a real-life deck example. Then read in the notes and start up the Phoenix app via the following: mix memorex . read_notes iex - S mix phx . server Navigate in your browser to http://localhost:4000 . All of the newly read notes start out as :new cards. Convert a bunch of :new cards to :learn cards by hitting the button &quot;Add New Learn Cards&quot;, and then review some cards by hitting the &quot;Review/Drill&quot; button!","ref":"readme.html","title":"","type":"extras"},{"doc":"A Memorex.Domain.Deck consists either of a Markdown file (in which case the deck name is the name of the markdown file [minus the .md extension]), or a directory which contains multiple markdown files and/or image &amp; text files (in which case the deck name is the name of the directory). There are two types of notes in Memorex ; &quot;text notes&quot; and &quot;image notes&quot;. A text note consists of a line of text in a Markdown file which contains either the unidirectional or bidirectional note delimitter. For example, for the vim deck with a bidirectional delimitter &quot;⮂&quot;, a note might consist of the following: How do you navigate to the end of a file? ⮂ G or for a unidirectional delimitter &quot;→&quot; in a deck country-capitals.md , a note may be: What is the capital of France ? → Paris You can specify both the bidirectional and unidirectional delimitters in environment variables if you wish to override Memorex's default values. The key idea is to have them be characters (or sequences of characters) which are relatively unique and would not otherwise show up in your note content. You can intermix unidirectional and bidirectional delimitters within a single deck. You can also put non-flashcard content in your deck Markdown files which will not be converted into flashcards; if a line doesn't have one of the delimitters, then it will simply be skipped over by the Memorex.Parser . This way you can take notes, and create flashcards only for certain pieces of content within that note file that you wish you drill on later. Image notes consist of a image files placed within a deck directory; each image file has a text file adjacent to it which contains the &quot;answer&quot; to the image. For example, if the image file is &quot;sequoia.jpg&quot; then the sibling text file &quot;sequoia.txt&quot; might contain &quot;Sequoia Sempervirens - Coastal Redwood&quot;. Image notes can have the extensions &quot;.jpg&quot;, &quot;.jpeg&quot;, &quot;.png&quot;, &quot;.webp&quot;, &quot;.svg&quot;, or &quot;.gif&quot;. Memorex.Domain.Card s are what are actually drilled; forward and reverse cards are created from a note if the bidirectional delimitter is present, and a single forward card is created from a note if the unidirectional delimitter is present (i.e., a note has one or two associated cards). That is, a deck contains many notes, and each note has one (or two) cards. When you answer a card, a Memorex.Domain.CardLog entry is created. If you update the content of the Markdown files which comprise your decks, the notes &amp; cards will be updated the next time you run the mix task mix memorex.read_notes . Any existing card whose parent note has been edited will be reset to start out as a :new card again (i.e., the drilling information associated with that card will be lost), although the note content will be updated within Memorex. This is because Memorex creates a linkage from the note in the Markdown (for text notes) file to the note in its database via a UUID based on a hash of the note content (together with the filename if the Markdown file is within a directory). Similary for image notes, the notes &amp; cards will be updated if either the image file content is changed, the content of its sibling text file is changed, or if the image &amp; text file are moved to a different location (for example, moving the image file/text file pair to a different deck directory).","ref":"readme.html#decks-notes-and-cards","title":" - Decks, Notes, and Cards","type":"extras"},{"doc":"Multiple Markdown files within a deck directory will result in the notes for that deck each having a &quot;category&quot; which is the name of the Markdown file. If Markdown note files (or image files with their corresponding text files) are in subdirectories within a deck directory, then the notes will have categories which are the names of the subdirectories (plus the name of the Markdown file if these are text notes). For example, for a deck directory named &quot;Spanish Vocabulary&quot;, a Markdown file within that directory called Spanish Vocabulary/Nouns/Household.md which contains the note line lavavajillas ⮂ dishwasher will result in a bidirectional note which has the category Nouns =&gt; Household . Similarly for image notes, if there is a image file/text file pair coast-live-oak.jpg and coast-live-oak.txt within a subdirectory inside of deck directory named California Native Plants , such as California Native Plants/Trees/Coastal/coast-live-oak.jpg and California Native Plants/Trees/Coastal/coast-live-oak.txt , then the resulting note will have the category Trees =&gt; Coastal .","ref":"readme.html#note-categories","title":" - Note Categories","type":"extras"},{"doc":"Similar to Anki, there are four answers for a flashcard: :again (which means you failed to answer the card), :hard , :good , and :easy . When you start to drill for the day, you'll need to convert a batch of :new cards to :learn cards on the deck listing page. A Memorex.Domain.Card starts out as a :new card; it is converted to a :learn card (by hitting the button on the MemorexWeb.DecksLive page) so that it can be drilled/reviewed. After progressing through the learning steps, the card becomes a :review card. If a :review card is failed (i.e., you answer it as :again then it is said to have lapsed, and becomes a :relearn card. It then must progress through the :relearn steps in order to become a :review card again. After :leech_threshold lapses in Mememorex.Scheduler.Config (by default, 8 lapses) then card switches from being :active to :suspended . All of this mirrors the Anki algorithm.","ref":"readme.html#drilling-reviewing-cards","title":" - Drilling/Reviewing Cards","type":"extras"},{"doc":"There is no notion of a &quot;user&quot; within Memorex nor shared decks; you share flashcard decks with other people by simply sharing the git repo which contains the flashcards.","ref":"readme.html#differences-with-anki","title":" - Differences with Anki","type":"extras"},{"doc":"Memorex's settings mimic closely the settings from Anki; see a detailed list of the Anki settings in this Anki forum . The Anki manual also contains a lot of information. You can override settings for all decks via environment variables; look in this file or in this file to see a list of available environment variables. You can also override settings on a per-deck basis. If your deck is a single markdown file (e.g., my-deck.md ) then you can override settings for this deck by placing a config file named my-deck.deck_config.toml adjacent to the deck file in your directory structure. If the deck is a directory, then just place a file named deck_config.toml within the directory. See this example deck settings config file to see the format of the settings and what is available. Note that if a value isn't specified, then the setting will default to either the environment variable's value (if one has been specified for this setting) or to Memorex's default value, so you only need to specify deck settings in the toml files for values that you wish to override. The current Memorex defaults are all equal to the Anki defaults, and Anki recommends that you use the default values for a few weeks and become comfortable with them before changing/customizing them.","ref":"readme.html#configuration","title":" - Configuration","type":"extras"},{"doc":"Duration fields (such as max_review_interval , min_review_interval , etc.) in Memorex.Scheduler.Config are specified using ISO-8601 format in environment variables and config files. For example, &quot;P1M10D&quot; means &quot;1 month, 10 days&quot;, and &quot;P3DT4H30M&quot; means &quot;3 days, 4 hours, &amp; 30 minutes&quot;.","ref":"readme.html#duration-fields","title":" - Duration Fields","type":"extras"},{"doc":"Memorex's domain code (e.g., in lib/memorex ) was created using a strict test-driven development (TDD) approach, and as such has an extremely high level of test coverage (close to 100%, in fact). The Anki algorithm was painstakingly researched and unwound, and test cases were created for every scenario (in fact, in the process of developing Memorex I found some existing documentation was incorrect by examining and running the tests in the Anki source code). The code for Memorex was also written with testability in mind; for example, Timex.now() is passed into most functions (rather than being called from within functions) so that time is deterministic for testing purposes, and the actual Anki logic is performed in a single module, CardStateMachine , which consists of pure functions and does not interact with the database nor external time. Some functions in various modules are made public that would normally be private functions just so that they can be properly tested (for example, Memorex.Parser has only one externally used function read_note_dirs/1 , but a lot of the other functions in there are public so they can be tested). By contrast, the LiveView code was only lightly tested, though (as time permits, I would like to backfill LiveView tests for these LiveViews, though!)","ref":"readme.html#development-process","title":" - Development Process","type":"extras"},{"doc":"Support for mathematical formulas is on the roadmap (via KaTeX ). Livebook integration is also a possibility (if I can figure out what that looks like!)","ref":"readme.html#future-features","title":" - Future Features","type":"extras"},{"doc":"These are the settings for a deck; get to these values by clicking on the gear icon to the right of a deck name, and select &quot;Options&quot;. These are the tooltip values that show up when you hover on the &quot;i&quot; icon next to the value's name. They are copied/pasted from the file deck-config.ftl This manual page also talks about the various deck settings. This Anki page is also useful. Read here about the Anki 2.1 scheduler , and here about the 2021 scheduler .","ref":"anki-deck-settings.html","title":"Anki Deck Settings","type":"extras"},{"doc":"New cards per day [default: 20] - The maximum number of new cards to introduce in a day, if new cards are available. Because new material will increase your short-term review workload, this should typically be at least 10x smaller than your review limit. Maximum reviews per day [default: 200] - The maximum number of review cards to show in a day, if cards are ready for review.","ref":"anki-deck-settings.html#daily-limits","title":"Anki Deck Settings - Daily Limits","type":"extras"},{"doc":"Learning steps [default: 1m 10m] - One or more delays, separated by spaces. The first delay will be used when you press the Again button on a new card, and is 1 minute by default. The Good button will advance to the next step, which is 10 minutes by default. Once all steps have been passed, the card will become a review card, and will appear on a different day. Delays are typically minutes (eg 1m ) or days (eg 2d ), but hours (eg 1h ) and seconds (eg 30s ) are also supported. Graduating interval [default: 1] - The number of days to wait before showing a card again, after the Good button is pressed on the final learning step. Easy interval [default: 4] - The number of days to wait before showing a card again, after the Easy button is used to immediately remove a card from learning. Insertion order [default: Sequential (oldest cards first) ] - Controls the position (due #) new cards are assigned when you add new cards. Cards with a lower due number will be shown first when studying. Changing this option will automatically update the existing position of new cards. (other value is Random )","ref":"anki-deck-settings.html#new-cards","title":"Anki Deck Settings - New Cards","type":"extras"},{"doc":"Relearning steps [default: 10 m] - Zero or more delays, separated by spaces. By default, pressing the Again button on a review card will show it again 10 minutes later. If no delays are provided, the card will have its interval changed, without entering relearning. Delays are typically minutes (eg 1m ) or days (eg 2d ), but hours (eg 1h ) and seconds (eg 30s ) are also supported. Minimum interval [default: 1] - The minimum interval given to a review card after answering Again . Leech threshold [default: 8] - The number of times Again needs to be pressed on a review card before it is marked asa leech. Leeches are cards that consume a lot of your time, and when a card is marked as a leech, it's a good idea to rewrite it, delete it, or think of a mnemonic to help you remember it. Leech action [default: Suspend Card ] - Tag Only : Add a &quot;leech&quot; tag to the note, and display a pop-up. Suspend Card : In addition to tagging the note, hide the card until it is manually unsuspended.","ref":"anki-deck-settings.html#lapses","title":"Anki Deck Settings - Lapses","type":"extras"},{"doc":"Maximum answer seconds [default: 60] - The maximum number of seconds to record for a single review. If an answer exceeds this time (because you stepped away from the screen for example), the time taken will be recorded as the limit you have set. Show answer timer [default: off] - In the review screen, show a timer that counts the number of seconds you're taking to review each card.","ref":"anki-deck-settings.html#timer","title":"Anki Deck Settings - Timer","type":"extras"},{"doc":"Bury new siblings [default: off] - Whether other cards of the same note (eg reverse cards, adjacent cloze deletions) will be delayed until the next day. Bury review siblings [default: off] - Whether other cards of the same note (eg reverse cards, adjacent cloze deletions) will be delayed until the next day.","ref":"anki-deck-settings.html#burying","title":"Anki Deck Settings - Burying","type":"extras"},{"doc":"Don't play audio automatically [default: off] - (no tooltip given) Skip question when replaying answer [default: off] - Whether the question audio should be included when the Replay action is used while looking at the answer side of a card.","ref":"anki-deck-settings.html#audio","title":"Anki Deck Settings - Audio","type":"extras"},{"doc":"Maximum interval [default: 36500] - The maximum number of days a review card will wait. When reviews have reached the limit, Hard , Good and Easy will all give the same delay. The shorter you set this, the greater your workload will be. Starting ease [default: 2.50] - The ease multiplier new cards start with. By default, the Good button on a newly-learned card will delay the next review by 2.5x the previous delay. Easy bonus [default: 1.30] - An extra multiplier that is applied to a review card's interval when you rate it Easy . Interval modifier [default: 1.00] - This multiplier is applied to all reviews, and minor adjustments can be used to make Anki more conservative or aggressive in its scheduling. Please see the manual before changing this option. Hard interval [default: 1.20] - The multiplier applied to a review interval when answering Hard . New interval [default: 0.00] - The multiplier applied to a review interval when answering Again .","ref":"anki-deck-settings.html#advanced","title":"Anki Deck Settings - Advanced","type":"extras"},{"doc":"","ref":"anki-notes.html","title":"Anki Notes","type":"extras"},{"doc":"Bury a Card: https://docs.ankiweb.net/studying.html#editing-and-more Hides a card or all of the note’s cards from review until the next day. (If you want to unbury cards before then, you can click the “unbury” button on the deck overview screen.) This is useful if you cannot answer the card at the moment or you want to come back to it another time. Burying can also happen automatically for cards of the same note. Suspend a Card / Note: Hides a card or all of the note’s cards from review until they are manually unsuspended (by clicking the suspend button in the browser). This is useful if you want to avoid reviewing the note for some time, but don’t want to delete it. With the old scheduler, if cards were in learning when they are suspended, they are moved back to the new card queue or review queue prior to being suspended.","ref":"anki-notes.html#anki-lingo","title":"Anki Notes - Anki &quot;Lingo&quot;","type":"extras"},{"doc":"These notes are based on dev work/experimentation that I did on 2021-12-12. Note that this development work was all done on a Mac. See this page from the Anki documentation for their description of the Anki build process.","ref":"anki-build-notes.html","title":"Anki Build Notes","type":"extras"},{"doc":"git clone git@github.com:ankitects/anki.git cd anki brew unlink bazel # conflicts with bazelisk brew install bazelisk To build and launch Anki (this takes a while): ./run","ref":"anki-build-notes.html#build-steps-for-anki","title":"Anki Build Notes - Build Steps for Anki","type":"extras"},{"doc":"To run tests in a directory: cd pylib/tests bazel test //... To run a specific test, e.g., test_schedv2 (the main Anki scheduling test): cd anki PYTEST=test_schedv2 bazel run //pylib:pytest","ref":"anki-build-notes.html#running-anki-tests","title":"Anki Build Notes - Running Anki Tests","type":"extras"},{"doc":"To print out an object from Python: from pprint import pprint pprint(vars(my_object))","ref":"anki-build-notes.html#debugging-anki-code","title":"Anki Build Notes - Debugging Anki Code","type":"extras"},{"doc":"From Anki Algorithm Explained in 5 minutes!","ref":"anki-algorithm-for-review-cards.html","title":"Anki Algorithm for Review Cards","type":"extras"},{"doc":"Default starting ease: 250% Default interval modifier: 100% Default hard interval: 120% Default easy bonus: 130%","ref":"anki-algorithm-for-review-cards.html#ease-factors","title":"Anki Algorithm for Review Cards - Ease Factors","type":"extras"},{"doc":"Press &lt;again&gt;: Go through lapse steps, then new interval becomes % of old interval AND subtract 20% from ease Press &lt;hard&gt;: new_interval = current_interval 1.2 (default hard interval) 1 (default interval modifier) AND subtract 15% from ease Press &lt;good&gt;: new_interval = current_interval 2.5 (ease%) 1 (default interval modifier) AND keep ease unchanged Press &lt;easy&gt;: new_interval = current_interval 2.5 (ease%) 1 (default interval modifier) * 1.3 (default easy bonus) AND add 15% to ease The Anki algorithm as described herein only applies to graduated (review) cards, not cards in the learning phase.","ref":"anki-algorithm-for-review-cards.html#responses","title":"Anki Algorithm for Review Cards - Responses","type":"extras"},{"doc":"The Anki scheduler is in anki/pylib/anki/scheduler/v2.py .","ref":"anki-algorithm-for-review-cards.html#anki-scheduler","title":"Anki Algorithm for Review Cards - Anki Scheduler","type":"extras"},{"doc":"A visual representation of the Anki algorithm: https://forums.ankiweb.net/t/deck-options-in-a-mental-map/15757 https://aws1.discourse-cdn.com/standard11/uploads/anki2/original/2X/8/852e362b5c6f1208feec3ac01047d6deab5e4a43.jpeg May 27, 2022 NOTE: the picture is WRONG for ansering :hard for review cards - you DO NOT multiply by the ease!!! It is also wrong for answering :good The picture: interval = interval card.ease_factor config.interval_multiplier From the Anki code: interval = (interval + (time.now - card.due)/2) card.ease_factor config.interval_multiplier It is also wrong for answering :easy The picture: interval = interval card.ease_factor config.interval_multiplier * config.easy_multiplier From the Anki code: interval = (interval + (time.now - card.due)) card.ease_factor config.interval_multiplier * config.easy_multiplier NOTE THAT THIS ONLY APPLIES IF TIME_NOW IS GREATER THAN CARD.DUE!!! i.e., you get a little benefit if you are answering a card late. This is explained here: https://faqs.ankiweb.net/due-times-after-a-break.html","ref":"anki-algorithm-mental-map.html","title":"Anki Algorithm Mental Map","type":"extras"}]